--- message.el-orig	Mon Jun 10 12:46:41 1996
+++ message.el	Mon Jun 10 14:58:43 1996
@@ -1954,7 +1954,13 @@
   "Return the \"real\" user address.
 This function tries to ignore all user modifications, and 
 give as trustworthy answer as possible."
-  (concat (user-login-name) "@" (system-name)))
+  (let ((domain (system-name)))
+    (or (string-match "[^.]\\.[^.]" domain)
+	(if (and (boundp 'mail-host-address) mail-host-address)
+	    (setq domain mail-host-address)
+	  ))
+    (concat (user-login-name) "@" domain)
+    ))
 
 (defun message-make-address ()
   "Make the address of the user."
